/*
 * I2C EEP-ROM AT24C1024B CgeXg@Version 1.00
 * File:        eeprom_w3c.c
 * Target:      PIC18F14K50 48MHz
 * RpC:   Microchip MPLAB XC8 C Compiler V1.20
 * :     PICKit 3
 * [X:     2013/10/08 20:00
 *
 * I2C EEP-ROM̃AhX 00000h?003ffh0,1,2,3,4EEE0ffh
 * RS232CgpĂ邪ڑȂĂ\
 *              e[q̐ڑ
 *              RC0 out     :LED0
 *              RC2 out     :LCD RS
 *              RC3 out     :LCD E
 *              RC4-RC7 out :LCD DB4-DB7
 *              SCL         :I2C EEPROM
 *              SDA         :I2C EEPROM
 *              RX          :MAX232C R2OUT
 *              TX          :MAX232C T2IN
*/

#include <stdio.h>
#include <stdlib.h>
#include <p18f14k50.h>
#include <plib\delays.h>
#include <plib\i2c.h>
#include <plib\usart.h>
#include "i2c_eep.h"

#pragma config  FOSC = HS,CPUDIV = NOCLKDIV,PLLEN=ON,WDTEN=OFF,LVP=OFF,MCLRE=OFF

#define I2CROM_ADS   0xa8 // 0xa8 10101000 0x00000?0x0ffff

#define LED0 PORTCbits.RC0

char rom_buf[256];
char rs232c_buf[64];

void make_test_ptn0(unsigned char* buf,unsigned int size){
    for(int n=0;n<size;n++)
        buf[n]=n;
}



void main(void) {
    signed char ret;

    ANSEL=0;
    ANSELH=0;
    SLRCON=0;
    TRISA=0;
    TRISB=0b11110000;
    TRISC=0b00000010;

    OpenUSART(USART_TX_INT_OFF & USART_RX_INT_OFF & USART_ASYNCH_MODE & USART_EIGHT_BIT & USART_CONT_RX & USART_BRGH_HIGH,155);
    OpenI2C(MASTER,SLEW_ON);    // }X^[
    SSPADD=230;

    putrsUSART("\n\rI2C EEPROM Write Test\n\r");

    Delay10KTCYx(240);    //  200ms * (48MHz/4)=2,400,000
    Delay10KTCYx(240);    //  200ms * (48MHz/4)=2,400,000

    LED0=1;
    unsigned short long test_ads=0;
    int n;
    for(n=0;n<4;n++){
        make_test_ptn0(rom_buf,256);
        sprintf(rs232c_buf,"Write %5.5lx %2.2x %2.2x\n\r",(unsigned long)test_ads,rom_buf[0],rom_buf[1]);
        putsUSART(rs232c_buf);

        if(ret=i2c_eepromWB(I2CROM_ADS,rom_buf,test_ads,256)){
            sprintf(rs232c_buf,"Error %i:%lx\n\r",(int)ret,(unsigned long)test_ads);
            putsUSART(rs232c_buf);
        }
        test_ads+=0x100;
    }

    while(1);
}

