/*
 * I2C EEPROM AT24C1024B ǂݏCu[ Version 1.00
 * File:        i2c_eep.c
 * Target:      PIC18F14K50 48Mhz
 * RpC:   Microchip MPLAB XC8 C Compiler V1.20
 * :     PICKit 3
 * [X:     2013/09/29 15:00
 *
*/

#include <p18f14k50.h>
#include <plib\delays.h>
#include <plib\i2c.h>
#include "i2c_ex.h"

signed char _i2c_eepromWB(unsigned char sads,void* p,unsigned short long ads,unsigned int size){
    unsigned char* buf=p;
    unsigned int n;
    signed char ret;
    do{
        SSPCON1bits.WCOL=0;
        IdleI2C();
        StartI2C();
        while(SSPCON2bits.SEN);
        if(PIR2bits.BCLIF)
            return -10;
    }while(SSPCON1bits.WCOL);
    unsigned char adsu=(ads>>15) & 0b1110;
    if(ret=i2c_write(sads | adsu )) // 3bitX[uAhXƍ
        return ret-2;
    if(ret=i2c_write(ads >> 8))
        return ret-4;
    if(ret=i2c_write(ads & 0xff))
        return ret-6;
    for(n=0;n<size;n++)
        i2c_write(buf[n]);
    StopI2C();
    while(SSPCON2bits.PEN);
    Delay10KTCYx(6);    //  5ms * (48MHz/4)=60,000
    return 0;
}

//  I2C EEPROM AT24C1024B ubN

signed char i2c_eepromWB(unsigned char sads,void* p,unsigned short long ads,unsigned int size){
    unsigned char try=TRY;
    signed char ret;
    do{
        if( (ret=_i2c_eepromWB(sads, p,ads,size)) == 0)
            break;
        Delay1TCYx( 24);  //  2s*(48MHz/4)= 24
    }while(--try);
    return ret;
}

signed char _i2c_eepromRB(unsigned char sads,unsigned char* buf,unsigned short long ads,unsigned int size){
    unsigned int n;
    signed char ret;
    unsigned char try;

    do{
        PIR1bits.SSPIF=0;
        PIR2bits.BCLIF=0;
        SSPCON1bits.WCOL=0;
        IdleI2C();
        StartI2C(); //  SEN=1
        while(SSPCON2bits.SEN); //  STARTI܂őҋ@
        if(PIR2bits.BCLIF)  //  SCL=0 SDA=0STARTsłȂꍇ
            return -10;

    }while(SSPCON1bits.WCOL);   //  oXՓ˂܂ŌJԂ
    SSPCON2bits.RCEN=0;
    unsigned char adsu=(ads>>15) & 0b1110;
    if(ret=i2c_write(sads | adsu)) // 3bitX[uAhXƍ
        return ret-2;
    if(ret=i2c_write(ads >> 8)) //  8bit
        return ret-4;
    if(ret=i2c_write(ads & 0xff))   //  8bit
        return ret-6;
    RestartI2C();   //  RSEN=1
    while(SSPCON2bits.RSEN);
    if(ret=i2c_write(sads  | adsu | 1)) // 3bitX[uAhXƍ
        return ret-8;
    while(DataRdyI2C());
    for(n=0;n<size-1;n++){
        PIR1bits.SSPIF=0;
        SSPCON2bits.ACKDT=0;
        buf[n]=ReadI2C();
        SSPCON1bits.SSPOV=0;
        SSPCON2bits.ACKEN=1;
        while(SSPCON2bits.ACKEN);
        SSPCON1bits.SSPOV=0;
        IdleI2C();
    }

    PIR1bits.SSPIF=0;
    while(DataRdyI2C());
 
    SSPCON2bits.ACKDT=1;
    buf[n]=ReadI2C();
    SSPCON2bits.ACKEN=1;
    while(SSPCON2bits.ACKEN);
    SSPCON1bits.SSPOV=0;
    IdleI2C();

    SSPCON2bits.RCEN=0;
    
    PIR1bits.SSPIF=0;
    SSPCON1bits.WCOL=0;
    StopI2C();
    while(SSPCON2bits.PEN);
    return 0;
}

//  I2C EEPROM AT24C1024B ubNǂݍ

signed char i2c_eepromRB(unsigned char sads,void* p,unsigned short long ads,unsigned int size){
    unsigned char try=TRY;
    signed char ret;
    do{
        if( (ret=_i2c_eepromRB(sads, p,ads,size)) == 0 )
            break;
        Delay1TCYx( 240);  //  2s*(48MHz/4)= 24
    }while(--try);
    return ret;
}
